  // LATO UTENTE 
 import java.awt.*;
 import java.awt.event.*;
 import java.io.*;
 import java.net.*;

public class FileDistribution extends Frame
{   
//classi interne per la gestione degli eventi
     
	 class ButtonListener implements ActionListener
     { public void actionPerformed(ActionEvent event)
            {Button source = (Button)event.getSource();
		     String message=null;
			 if (source==richiediButton)
			        richiedi();      //richiede un file al sistema
			  else if(source==inserisciButton)
			        inserisci();     //inserisce un nuovo file nel sistema
			  else if(source==rimuoviButton)
			        rimuovi();	     //rimuove un file dal sistema
			  else if(source==taButton)
			        tabReq();
            }
     }
	 
     class FrameListener extends WindowAdapter
     { public void windowClosing(WindowEvent e)
                     {e.getWindow().dispose();
                     }	 
	   public void windowClosed(WindowEvent e)
                     {System.exit(0);
                     }
     } 

     //layout
//	 BorderLayout layout = new BorderLayout();
	 //componenti
	 	 
	 Panel contentPanel = new BorderedPanel();
	 Label fileLabel = new Label("Nome file:"); 
	 TextField fileField = new TextField("",20);
	 Label hostLabel = new Label("Indirizzo Host, se necessario");
	 TextField hostField = new TextField("",20);
	 Button richiediButton = new Button();
	 Button inserisciButton = new Button();
	 Button rimuoviButton = new Button();
	 Button taButton = new Button();
	 Dialog tab;
	 
	 // Name Server
	 String ns1;
	 String ns2;
	 
	 // listener
	 FrameListener frameListener=new FrameListener();
	 ButtonListener buttonListener=new ButtonListener();
	 
//costruttore	 
	 
	 public FileDistribution(String ns1, String ns2)


       { //server dei nomi
	   this.ns1=ns1;
	   this.ns2=ns2;
	
	 //imposta le propriet del frame
	   this.setTitle("Sistema di condivisione di file");
	   this.setSize(220,400);
	   this.setResizable(false);
	   
	   //  imposta il layout del frame
//	   this.setLayout(layout); 
      
	  //  imposta le propriet dei pulsanti
	  richiediButton.setLabel("Richiedi");
	  inserisciButton.setLabel("Inserisci");
	  rimuoviButton.setLabel("Rimuovi");
	  taButton.setLabel("Richiedi elenco file disponibili");
	  
	  //inserisce i pulsanti, i campi e le label nel panel
	  contentPanel.add(fileLabel);
	  contentPanel.add(fileField);
	  contentPanel.add(hostLabel);
	  contentPanel.add(hostField);
	  contentPanel.add(richiediButton);
	  contentPanel.add(inserisciButton);
	  contentPanel.add(rimuoviButton);
	  contentPanel.add(taButton);
	  
	  //inserisce il panel nel frame
	  this.add(contentPanel,BorderLayout.CENTER);
	  
	  //assegna il listener al frame
	  this.addWindowListener(frameListener);
	  
	  //collega il listener ai pulsanti
	  richiediButton.addActionListener(buttonListener);
	  inserisciButton.addActionListener(buttonListener);
	  rimuoviButton.addActionListener(buttonListener);
	  taButton.addActionListener(buttonListener);
	 }
//-----------------------------------------------------------------------
	 //NOTA. IL FORMATO DEL MESSAGGIO E':comando&host&nomefile&  MA IN RICHIEDI() 
//NON HA IMPORTANZA, PERO' VA MESSO AD ES. 200&&pippo.txt& opp. 200&qualunquecosa&pippo.txt&
	 public void richiedi()
	 {  String nomeFile=new String(fileField.getText());
	    String nomeHost="nonimporta";
		if(nomeFile.equals(""))
		  new MessageDialog(this, "Attenzione",
		     "Specificare il nome del file che si vuole richiedere",true).show();
		else
		{hostField.setText("");
		 String comando="200";  // richiedi
		
		 EntryCommand entry  = new EntryCommand(comando,nomeHost,nomeFile);
		 RichiediT richiediT;
		 if(nomeFile.compareTo("n")<=0)               // si dividono le richieste in base all'ordine alfabetico
		     richiediT = new RichiediT(this,entry,ns1);    //nomi  minori di  "n" in NS1
		 else richiediT = new RichiediT(this,entry,ns2);
  //nomi maggiori di "n" in NS2
		 Thread t=new Thread(richiediT);
		 t.start();
		}
	//il file verr salvato nella directory ./client
	
	 }
//-------------------------------------------------------------------------	 
	 public void inserisci()
	 {  String nomeFile=new String(fileField.getText());
	    String host=new String(hostField.getText());
		if(nomeFile.equals(""))
			new MessageDialog(this, "Attenzione",
		     "Specificare il nome del file che si intende inserire",true).show();
		else if(host.equals(""))
		    new MessageDialog(this, "Attenzione",
		     "Specificare il nome dell'host locale",true).show();
		else
		{	 
		String comando="100";  // inserisci
		EntryCommand entry=new EntryCommand(comando,host,nomeFile);
		InserisciT inserisciT;
		 if(nomeFile.compareTo("n")<=0)               // si dividono gli inserimenti in base all'ordine alfabetico
		     inserisciT = new InserisciT(this,entry,ns1);    //nomi  minori di  "n" in NS1
		 else inserisciT = new InserisciT(this,entry,ns2);
  //nomi maggiori di "n" in NS2
		Thread t=new Thread(inserisciT);
		t.start();
		}
		
	 }
//-------------------------------------------------------------------------
	 public void rimuovi()
	 {  String nomeFile=new String(fileField.getText());
	    String host=new String(hostField.getText());
		if(nomeFile.equals(""))
			new MessageDialog(this, "Attenzione",
		     "Specificare il nome del file che si intende rimuovere",true).show();
		else if(host.equals(""))
		    new MessageDialog(this, "Attenzione",
		     "Specificare il nome dell'host locale",true).show();
		else
		{	 
		String comando="300";  // rimuovi
		EntryCommand entry=new EntryCommand(comando,host,nomeFile);
		RimuoviT rimuoviT;
		 if(nomeFile.compareTo("n")<=0)               // si dividono le rimozioni in base all'ordine alfabetico
		     rimuoviT = new RimuoviT(this,entry,ns1);    //nomi  minori di  "n" in NS1
		 else rimuoviT = new RimuoviT(this,entry,ns2);
  //nomi maggiori di "n" in NS2
		Thread t=new Thread(rimuoviT);
		t.start();
		}
	 }
//--------------------------------------------------------------------------
             //RICHIEDI  LISTA FILE
         public void tabReq()    //server suula porta 2001
         {try
            {  
         
            try
            {tab.dispose();
            }catch(NullPointerException e)
            {
            }
            tab= new Dialog(this);
            tab.setTitle("File disponibili");
            tab.setSize(400,400);
            tab.setResizable(false);
            TextArea list = new TextArea();
            tab.add(list);
            tab.show();
            tab.setModal(true);    //durante il caricamento nella finestra non si puo fare altro
            
            InetAddress inetAddress1=InetAddress.getByName(ns1); 
            InetAddress inetAddress2=InetAddress.getByName(ns2);

            Socket socket;
                //NAME SERVER 1
            try
            {socket = new Socket(inetAddress1,2001);
            
            InputStream in = socket.getInputStream();
            
            int x;
            ByteArrayOutputStream line=new ByteArrayOutputStream();
            ByteArrayOutputStream car=new ByteArrayOutputStream();
            while((x=in.read())>-1)
            {car.reset();
             car.write(x);
             //----
             if(car.toString().equals("$"))
             {char tochar[]=line.toString().toCharArray();
             int i=0;
             
             StringBuffer command=new StringBuffer();
             StringBuffer host =new StringBuffer();
             StringBuffer nome= new StringBuffer();
             
             while(tochar[i]!='&')
              { 
                command=command.append(tochar[i]);
                i++;
              }
             i++;
             
             while(tochar[i]!='&')
              { 
                host=host.append(tochar[i]);
                i++;
              }
             i++;
             
             while(tochar[i]!='&')
              { 
                nome=nome.append(tochar[i]);
                i++;
              }
             System.out.println(nome);
             Entry entry=new Entry(host.toString(),nome.toString());
             
             list.append(entry.getFilename()+'\n');
             line.reset();  
            
             }//fine if
             //-----
             else
               {line.write(x);
               }
             //-----
           
           }  //fine while
           
           socket.close();
           
           }catch(ConnectException e)
           {
           }
                          //NAMESERVER2
           try
            {socket = new Socket(inetAddress2,2001);
            
            InputStream in = socket.getInputStream();
            
            int x;
            ByteArrayOutputStream line=new ByteArrayOutputStream();
            ByteArrayOutputStream car=new ByteArrayOutputStream();
            while((x=in.read())>-1)
            {car.reset();
             car.write(x);
             //----
             if(car.toString().equals("$"))
             {char tochar[]=line.toString().toCharArray();
             int i=0;
             
             StringBuffer command=new StringBuffer();
             StringBuffer host =new StringBuffer();
             StringBuffer nome= new StringBuffer();
             
             while(tochar[i]!='&')
              { 
                command=command.append(tochar[i]);
                i++;
              }
             i++;
             
             while(tochar[i]!='&')
              { 
                host=host.append(tochar[i]);
                i++;
              }
             i++;
             
             while(tochar[i]!='&')
              { 
                nome=nome.append(tochar[i]);
                i++;
              }
             System.out.println(nome);
             Entry entry=new Entry(host.toString(),nome.toString());
             
             list.append(entry.getFilename()+'\n');
             line.reset();
             
             }//fine if  
             //-----
             else
               {line.write(x);
               }
             //-----
           
           }  //fine while
           
           socket.close();
           
           }catch(ConnectException e)
           {
           }
           
           tab.setModal(false);     //fine modal
           
           }catch(Exception e)
           {
           }
        }

	
//-------------------------------------------------------------------------- 
	 public static void main(String args[])
	 { if(args.length!=2)return;
	   FileDistribution fileDistribution=new FileDistribution(args[0],args[1]);
	   try
	   {InetAddress in=InetAddress.getLocalHost();
	   System.out.println(in.getHostName());
	   }catch(UnknownHostException e)
	   {
	   }
	    //ricavo la directory corrente
	   File currentDir = new File("x");
       currentDir = new File(currentDir.getAbsolutePath());
	   currentDir = new File(currentDir.getParent());
	    //verifico l'esistenza delle directory ./client e ./server
		//il caso negativo le creo
	   File serverDir = new File(currentDir.getAbsolutePath(),"serverDir");
	   File clientDir = new File(currentDir.getAbsolutePath(),"clientDir");
	   if(!serverDir.exists())serverDir.mkdir();
	   else if (serverDir.isFile()){ 
	      new MessageDialog(fileDistribution, "Attenzione",
		     "Esiste gi un file con il nome serverDir",true).show();
		  System.exit(0);}	 
	   if(!clientDir.exists())clientDir.mkdir();
	   else if (serverDir.isFile()){ 
	      new MessageDialog(fileDistribution, "Attenzione",
		     "Esiste gi un file con il nome clientDir",true).show();
		  System.exit(0);}	
	   
	    
	   fileDistribution.show();
	 }
} 

//*********************************	  

class BorderedPanel extends Panel
{  BorderedPanel()
   { FlowLayout layout = (FlowLayout)getLayout();
     layout.setAlignment(FlowLayout.LEFT);
   }

   public void paint(Graphics g)
   {  super.paint(g);
      Dimension size=getSize();
	  g.setColor(Color.red);
	  g.drawRect(3,3,(size.width - 6),(size.height - 6));
   }
}   


//*********************************
    //messaggio di avviso con pulsante di chiusura
class MessageDialog extends Dialog
  {  String message;
  	 TextArea messageText;
	 Button closeButton;
	 
	 public MessageDialog(Frame owner, String title, String message, boolean modal)
	 { 
	 	 super(owner, title, modal);
		 setBounds(100,100,300,300);
		 setLayout(new BorderLayout());
		 createMessageText(message);
		 createCloseButton();
	 }
	 
	 public void createMessageText(String message)
	 {   messageText = new TextArea(message,0,0,TextArea.SCROLLBARS_NONE);
	     messageText.setEditable(false);
		 add(messageText,BorderLayout.CENTER);
	 } 
	 
	 public void createCloseButton()
	 {   closeButton = new Button("Chiudi");
	closeButton.addActionListener(
	   new ActionListener()
	   {     public void actionPerformed(ActionEvent e)
             {dispose();
             }
	   }
    );
    add(closeButton,BorderLayout.SOUTH);


	 }
  }


//*************************RICHIEDI


class RichiediT implements Runnable
{      String comando;
	   String nomeHost;
	   String nomeFile;
	   Frame parentDialog;
	   String server;
       public RichiediT(Frame parentDialog,EntryCommand entry,String server)
       {  this.comando=entry.getCommand();
	      this.nomeHost=entry.getHost();
		  this.nomeFile=entry.getFilename();
		  this.parentDialog=parentDialog;
		  this.server=server;
       }
	   public void run()
	   { 
	    try{
	         InetAddress inetAddress=InetAddress.getByName(server);
	         	     
		 DatagramSocket dSocket=new DatagramSocket(2000,InetAddress.getLocalHost());//porta e ind. locali
	
		 ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		 DataOutputStream doStream=new DataOutputStream(boStream);
		 doStream.writeUTF(comando+"&"+nomeHost+"&"+nomeFile+"&");
		 byte data[]= boStream.toByteArray();
		 byte buf[]=new byte[65535];
		 
		 //nel packet andrebbe messo il nome del name server
		 DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2001);
		 DatagramPacket rPacket= new DatagramPacket(buf,buf.length);
		 dSocket.setSoTimeout(4000);
		 int count=0;
		 boolean serverUp=true;
		 
		 while (count<4){
		  try{
		  dSocket.send(dPacket);
		  dSocket.receive(rPacket);
		
		  count=4;
		  }catch(InterruptedIOException e)
		  {count++;
		   if(count==4)serverUp=false;  
		  }	
		 }			 
		 if(serverUp==false)
		     new MessageDialog(parentDialog, "Attenzione",
		     "Il Name Server non risponde",true).show();
		 else 
		 {Estrai estrai=new Estrai(rPacket);
		  EntryCommand entryC=estrai.estraiDati();
		  if(entryC.getCommand().equals("220"))//non esiste il file con quel nome
		       new MessageDialog(parentDialog, "Attenzione","Il file "+entryC.getFilename()+
		                        " non  registrato nel Name Server",true).show();
		  else if(entryC.getCommand().equals("210"))
		  {dSocket.close();
		   System.out.println(entryC.getHost());
		   LeggiFile leggiFile=new LeggiFile(parentDialog,entryC.getHost(),entryC.getFilename());
		   leggiFile.connect();		
		  }
		  else
		     new MessageDialog(parentDialog, "Attenzione",
		             "Errore nella comunicazione con il Name Server",true).show();
		  
		  	 
		 }
		 dSocket.close();
		 
		}catch(UnknownHostException e)
	    {e.printStackTrace();
	    }
		 catch(SocketException e)
		{e.printStackTrace();
		}
		catch(Exception e)
		{e.printStackTrace();
		}
	   }

}

//*************************INSERISCI

class InserisciT implements Runnable
{  protected Frame parentDialog;
   protected String command;
   protected String host;
   protected String fileName; 
   String server;
   public InserisciT(Frame parentDialog,EntryCommand entryC,String server)
   {this.parentDialog=parentDialog;
    this.command=entryC.getCommand();
	this.host=entryC.getHost();
	this.fileName=entryC.getFilename();  
	this.server=server; 
   }
   public void run()
   { try{
	     InetAddress inetAddress=InetAddress.getByName(server);
	     
		 DatagramSocket dSocket=new DatagramSocket(2000,InetAddress.getLocalHost());//porta e ind. locali
		 
		 ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		 DataOutputStream doStream=new DataOutputStream(boStream);
		 doStream.writeUTF(command+"&"+host+"&"+fileName+"&");
		 byte data[]= boStream.toByteArray();
		 byte buf[]=new byte[65535];
		 
		 //nel packet andrebbe messo il nome del name server
		 DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2001);
		 DatagramPacket rPacket= new DatagramPacket(buf,buf.length);
		 dSocket.setSoTimeout(4000);  //Timeout di 5 secondi
		 int count=0;
		 boolean serverUp=true;
		 
		 while (count<4){   //quattro tentativi prima di rinunciare
		  try{
		  dSocket.send(dPacket);
		  dSocket.receive(rPacket);
		
		  count=4;
		  }catch(InterruptedIOException e)
		  {count++;
		   if(count==4)serverUp=false;  
		  }	
		 }			 
		 if(serverUp==false)
		     new MessageDialog(parentDialog, "Attenzione",
		     "Il Name Server non risponde",true).show();
		 else 
		 {Estrai estrai=new Estrai(rPacket);
		  EntryCommand entry=estrai.estraiDati();
		 	  		  
		  if (entry.getCommand().equalsIgnoreCase("120"))//esiste gi un file con quel nome 
		  { 	  
		    if(host.equalsIgnoreCase(entry.getHost()))
			   new MessageDialog(parentDialog, "Attenzione",
		               "Inserimento di "+entry.getFilename()+" riuscito.",true).show();
			else
			   new MessageDialog(parentDialog, "Attenzione","Il nome di file "+
			                          entry.getFilename()+"  gi in uso",true).show();
	 	  }	   
		  else if(entry.getCommand().equalsIgnoreCase("110"))
		  {new MessageDialog(parentDialog, "Attenzione",
		               "Inserimento di "+entry.getFilename()+" riuscito.",true).show();
		  }
		 }				  	 
		 dSocket.close();
		
		}catch(UnknownHostException e)
	    {e.printStackTrace();
	    }
		 catch(SocketException e)
		{e.printStackTrace();
		}
		catch(Exception e)
		{e.printStackTrace();
		}  
   }
}

//**********************************RIMUOVI
class RimuoviT implements Runnable
{  protected Frame parentDialog;
   protected String command;
   protected String host;
   protected String fileName; 
   String server;
   public RimuoviT(Frame parentDialog,EntryCommand entry,String server)
   {this.parentDialog=parentDialog;
    this.command=entry.getCommand();
	this.host=entry.getHost();
	this.fileName=entry.getFilename(); 
	this.server=server;  
   }
   public void run()
   { try{
	     InetAddress inetAddress=InetAddress.getByName(server);
	     System.out.println("sono qui 0");
		 DatagramSocket dSocket=new DatagramSocket(2000,InetAddress.getLocalHost());//porta e ind. locali
		 ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		 DataOutputStream doStream=new DataOutputStream(boStream);
		 doStream.writeUTF(command+"&"+host+"&"+fileName+"&");
		 byte data[]= boStream.toByteArray();
		 byte buf[]=new byte[65535];
		 
		 //nel packet andrebbe messo il nome del name server
		 DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2001);
		 DatagramPacket rPacket= new DatagramPacket(buf,buf.length);
		 dSocket.setSoTimeout(4000);
		 int count=0;
		 boolean serverUp=true;
		 
		 while (count<4){   
		  try{
		  dSocket.send(dPacket);
		  dSocket.receive(rPacket);
		  count=4;
		  }catch(InterruptedIOException e)
		  {count++;
		   if(count==4)serverUp=false;  
		  }	
		 }			 
		 if(serverUp==false)
		     new MessageDialog(parentDialog, "Attenzione",
		     "Il Name Server non risponde",true).show();
		 else 
		 {Estrai estrai=new Estrai(rPacket);
		  EntryCommand entry=estrai.estraiDati();
		  if (entry.getCommand().equals("320"))//non esiste un file con quel nome 
		  {   new MessageDialog(parentDialog, "Attenzione","Il file "+entry.getFilename()+
		                        " non  presente sul Name Server",true).show();
		  }	   
		  else if(entry.getCommand().equals("310"))
		  {new MessageDialog(parentDialog, "Attenzione",
		               "Eliminazione di "+entry.getFilename()+" riuscita.",true).show();
		  }
		 }
				  	 
		 dSocket.close();
		}catch(UnknownHostException e)
	    {e.printStackTrace();
	    }
		 catch(SocketException e)
		{e.printStackTrace();
		}
		catch(Exception e)
		{e.printStackTrace();
		}	  
  }
}

//********************************


class Entry
{protected String host;
 protected String nomefile;
 protected int time;
 public Entry(String host,String nomefile)
 {this.host=host;
  this.nomefile=nomefile;
  this.time=0;
  }
 public Entry(String host,String nomefile,int time)
 {this.host=host;
  this.nomefile=nomefile;
  this.time=time;
  }
 public Entry()
 {this.time=0;
 }
  
 public String getHost()
 {return(host);
 }
 public String getFilename()
 {return(nomefile);
 }
 public int getTime()
 {
  return(time);
 }
 public void setTime(int time)
 {this.time=time;
 }
}


//*******************************


class EntryCommand extends Entry
{protected String command;
 public EntryCommand(String command,String host,String nomefile)
 {super(host,nomefile);
  this.command=command;
 }
 public String getCommand()
 {return(command);
 }
}

//******************************

class Estrai
{ protected DatagramPacket packet;
  public Estrai(DatagramPacket packet)
  {this.packet=packet;
  }
  public EntryCommand estraiDati() throws IOException
  {       
             ByteArrayInputStream biStream=new ByteArrayInputStream(packet.getData(),0,
		                                              packet.getLength());
		     DataInputStream diStream=new DataInputStream(biStream); 
			 
             String message = diStream.readUTF();
			 
			  //il messaggio viene interpretato
			 char tochar[]=message.toCharArray();
			 int i=0;
	  
             StringBuffer command=new StringBuffer();
	         StringBuffer host=new StringBuffer();
	         StringBuffer nome=new StringBuffer();
	  
	         while (tochar[i]!='&')
	         { 
	  	       command=command.append(tochar[i]);
			   i++;
	         }
		     i++;
				
	         while (tochar[i]!='&')
	         { 
	  	       host=host.append(tochar[i]);
			   i++;
	         } 
	         i++;
				
	         while (tochar[i]!='&')
	         {  
	  	        nome=nome.append(tochar[i]);
				i++;
	         }

             EntryCommand entry=new EntryCommand(command.toString(),host.toString(),
			 		                  nome.toString());
				  
			 return(entry);
            
			
  }
}


//********************




class LeggiFile
{  protected String host;
   protected int port=2000;
   protected DataInputStream in;
   protected PrintStream out;
   protected String fileName;
   protected Frame parentDialog;
   
   public LeggiFile(Frame parentDialog,String host,String fileName)
   {this.fileName=fileName;
    this.parentDialog=parentDialog;
	this.host=host;
   }
   public void connect()
    {
	 try{
	 byte b[]=new byte[65535];
	 InetAddress inet=InetAddress.getLocalHost();
	 InetAddress inetAddress=InetAddress.getByName(host);	
	 Socket socket=new Socket(inetAddress,port);
	 System.out.println("connessione avvenuta..");
	 
	 File currentDir = new File("x");
     currentDir = new File(currentDir.getAbsolutePath());
	 currentDir = new File(currentDir.getParent());
		   
	 File serverDir = new File(currentDir.getAbsolutePath(),"clientDir");
	 currentDir = new File(serverDir.getAbsolutePath());
     
     File file = new File(currentDir.getAbsolutePath(),fileName);
	 FileOutputStream f=new FileOutputStream(file);
	
	 BufferedOutputStream buffOut=new BufferedOutputStream(socket.getOutputStream());
	 out = new PrintStream(buffOut);
	 in=new DataInputStream(socket.getInputStream());
	
	 System.out.println("richiesta al server");
	 
	 out.println(fileName);
	 out.flush();
	 int num;	
	 while((num=in.read(b))>-1)
		   	  {f.write(b,0,num);
		   	                         }
	 f.flush();	
         f.close();  
		 
	 }catch(Exception e)
	 {e.printStackTrace();
	 } 
    }

}   


//**********************

class EqualString
{ String s1;
  String s2;

  public EqualString(String s1,String s2)
  {this.s1=s1;
   this.s2=s2;
  }  
  
  public boolean confronta()
  {char a1[]=s1.toCharArray();
   char a2[]=s2.toCharArray();
   if (a1.length==a2.length)
    {for(int i=0;i<a1.length;i++)
       if(a1[i]!=a2[i])return(false);
	 return(true);
    }
   else return(false);
  } 
}