import java.net.*;
import java.io.*;



  
public class InetReceiver 
{      InetAddress inetAddress;
       Tabella tabella;
       String slave;
	   int maxTime=1000;
	   public InetReceiver(Tabella tabella, String slave)
       {this.tabella=tabella;
        this.slave=slave;
       }
	 //**************  
	   class Gestore implements Runnable  //questa classe si occupa di servire le richieste
	     { DatagramPacket packet;                               //   da parte dei client
		   EntryCommand entryCommand;
		   public Gestore(DatagramPacket packet,EntryCommand entry) 
		   {this.packet=packet;
		    this.entryCommand=entry;   
		   }		   
		   public void run()
	       { try
	         {		 
	        
		   if(entryCommand.getCommand().equals("100"))//comando di inserimento
			  {
			  //bisogna prima controllare se c' gi un file con quel nome
			  
	          Entry entry= new Entry();
	          entry=tabella.getByFilename(entryCommand.getFilename());
			  //se il nome non  presente entry conterr stringhe nulle
			  
	          if (entry.getFilename().equals(""))
			  {//spedisco 110, il file non era presente
			   
			   tabella.insert(new Entry(entryCommand.getHost(),entryCommand.getFilename()));
			   
			   entry=tabella.getByFilename(entryCommand.getFilename());
			    
			  inetAddress=InetAddress.getLocalHost();
	          
		      DatagramSocket dSocket=new DatagramSocket();//ogni thread avr una porta diversa
			  
		      ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		      DataOutputStream doStream=new DataOutputStream(boStream);
		      doStream.writeUTF("110"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		      byte data[]= boStream.toByteArray();
		  
		      DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      inetAddress,2000);
		      Estrai estrai=new Estrai(dPacket);     //estraggo i dati e li passo ad un thread
		      EntryCommand entry1=estrai.estraiDati();	
			  
			  dSocket.send(dPacket);
	          }
			  
		      else
			  { //spedisco 120, il file  gi presente(dico anche chi ha il file)
			  
			  inetAddress=InetAddress.getLocalHost();
	          
		      DatagramSocket dSocket=new DatagramSocket();
			  
		      ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		      DataOutputStream doStream=new DataOutputStream(boStream);
		      doStream.writeUTF("120"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		      byte data[]= boStream.toByteArray();
		  
		      DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
			  
			    
		      dSocket.send(dPacket);
			  }
		   }	 
		  //--------------
			  
		  else if(entryCommand.getCommand().equals("200"))//comando di richiesta
			 {
			  Entry entry= new Entry();
			  entry=tabella.getByFilenameTozero(entryCommand.getFilename());
			  //se il nome  presente il campo time viene azzarato, se non  presente  gi 0
			  if (entry.getFilename().equals(entryCommand.getFilename()))//il server pu fornire la locazione del file 
			    {
			    inetAddress=InetAddress.getLocalHost();
	          
		        DatagramSocket dSocket=new DatagramSocket();
				
		        ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		        DataOutputStream doStream=new DataOutputStream(boStream);
		        doStream.writeUTF("210"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		        byte data[]= boStream.toByteArray();
		  
		        DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
		        dSocket.send(dPacket);
			    }
			  else //bisogna comunicare al client che il nome non  presente
			    {inetAddress=InetAddress.getLocalHost();
	          
		        DatagramSocket dSocket=new DatagramSocket();
		        
				ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		        DataOutputStream doStream=new DataOutputStream(boStream);
		        doStream.writeUTF("220"+"&"+entryCommand.getHost()+
				                               "&"+entryCommand.getFilename()+"&");
		        byte data[]= boStream.toByteArray();
		        DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
		        dSocket.send(dPacket);
				dSocket.close();
			    }
		   }	
		  //--------------
			 
		  else if(entryCommand.getCommand().equals("300")) //comando di eliminazione
		 	 {
			  //bisogna prima controllare se c' un file con quel nome
			  Entry entry= new Entry();
	          entry=tabella.getByFilename(entryCommand.getFilename());
	          
	          if (entry.getFilename().equals(entryCommand.getFilename()))//se il nome  presente...
			  {
			  if (entry.getHost().equals(entryCommand.getHost()))//se l'host corrisponde
			   {System.out.println("il file  presente"); 
			    tabella.removeByFilename(entryCommand.getFilename()); //...lo rimuovo..
			    //..e spedisco 310
			    inetAddress=InetAddress.getLocalHost();
	          
		        DatagramSocket dSocket=new DatagramSocket();
		 
		        ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		        DataOutputStream doStream=new DataOutputStream(boStream);
		        doStream.writeUTF("310"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		        byte data[]= boStream.toByteArray();
		  
		        DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
		        dSocket.send(dPacket);
		        
		        boStream.reset();
		        doStream.writeUTF("300"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		        data=boStream.toByteArray();
		        dPacket= new DatagramPacket(data,data.length,InetAddress.getByName(slave),2003);
		        dSocket.send(dPacket);
		        dSocket.send(dPacket);//due volte per prevenire una perdita di un messaggio
		        
		        
			dSocket.close();
			   }
			  else
			   { //spedisco 320, il file non  registrato nella tabella
			    System.out.println("il file NON  presente"); 
				inetAddress=InetAddress.getLocalHost();
	          
		        DatagramSocket dSocket=new DatagramSocket();
		 
		        ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		        DataOutputStream doStream=new DataOutputStream(boStream);
		        doStream.writeUTF("320"+"&"+entryCommand.getHost()+"&"+entryCommand.getFilename()+"&");
		        byte data[]= boStream.toByteArray();
		  
		        DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
		        dSocket.send(dPacket);
				dSocket.close();
			   }			   
			  }
		      else
			  { //spedisco 320, il file non  registrato nella tabella
			    System.out.println("il file NON  presente"); 
				inetAddress=InetAddress.getLocalHost();
	          
		        DatagramSocket dSocket=new DatagramSocket();
		 
		        ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		        DataOutputStream doStream=new DataOutputStream(boStream);
		        doStream.writeUTF("320"+"&"+entryCommand.getHost()+"&"+entryCommand.getFilename()+"&");
		        byte data[]= boStream.toByteArray();
		  
		        DatagramPacket dPacket= new DatagramPacket(data,data.length,
			                                      packet.getAddress(),2000);
		        dSocket.send(dPacket);
				dSocket.close();
			  }
		 	 }//fine 300
		     
	        }catch(Exception e)
	        {System.out.println("sono nel catch del thread");
	        }
	       }//fine run()
	     }//fine classe Gestore
     
	 //*********

class InviaTabella implements Runnable     //questa classe si occupa di inviare elementi
{                                          //della tabella a nodo SLAVE attraverso porta 2002
   public InviaTabella()
   {
   }
   public void run()
   { try{
		 InetAddress inetAddress=InetAddress.getByName(slave);
	     DatagramSocket dSocket=new DatagramSocket(2002,InetAddress.getLocalHost());//porta e ind. locali
		 ByteArrayOutputStream boStream=new ByteArrayOutputStream();
		 DataOutputStream doStream=new DataOutputStream(boStream);
		 System.out.println("Avviato Thread di gestione protocollo di duplicazione...");
		 
		  for(;;)//ogni 10 secondi (almeno) invia la tabella allo slave sulla porta 2003
		  {
		   Thread.sleep(10000);
		   System.out.println("Invio tabella allo SLAVE...");
     	   for(int i=0;i<Tabella.NUM;i++)
		    {
             Entry entry=tabella.getByIndexT(i,maxTime); //incrementa il tempo della entry
			 
			 if(entry.getFilename().equals(""))continue;
			 if (entry.getTime()<maxTime)
			  {
			  doStream.writeUTF("100"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
			  byte data[]= boStream.toByteArray();
			  DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2003);
			  dSocket.send(dPacket);
			  boStream.reset();			
 		      }
			 else if(entry.getTime()==maxTime)
			 {
			  doStream.writeUTF("300"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
			  byte data[]= boStream.toByteArray();
			  DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2003);
			  dSocket.send(dPacket);
			  boStream.reset();			
 		     }
		    }
		  }	 
	      	    
		}catch(UnknownHostException e)
	    {e.printStackTrace();
	    }
		 catch(SocketException e)
		{e.printStackTrace();
		}
		catch(Exception e)
		{e.printStackTrace();
		}  
   }
}
	   
	   
	 //*********  
	 
	 
  class ClienTab implements Runnable
    {
     public void run()
     {
     try{
         System.out.println("Avvio thread di invio lista dei nomi ai client...");
     ServerSocket server=new ServerSocket(2001);
     
     for(;;)
     {
     Socket master=server.accept();  //aspetta una richiesta di caricamento della tabella
     OutputStream o=master.getOutputStream();
     BufferedOutputStream buf=new BufferedOutputStream(o);
     DataOutputStream doStream=new DataOutputStream(buf);
     for(int i=0;i<Tabella.NUM;i++)
       {
       Entry entry=tabella.getByIndex(i);
       if(entry.getFilename().equals(""))continue;
       doStream.writeUTF("100"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
       doStream.writeUTF("$");
       }
     buf.flush();
     master.close();
     }//fine for(;;)
     
     }catch(Exception e)
     {e.printStackTrace();
     }
     
     }//fine run
    
  }
  
        //*********

	   public void startServer()
	   {
//avvio GESTORE INVII DELLA LISTA DEI NOMI AI CLIENT
	   ClienTab clienTab=new ClienTab();
	   new Thread(clienTab).start();
	   	      
	    try{
	    inetAddress=InetAddress.getLocalHost(); 		 
		DatagramSocket dSocket=new DatagramSocket(2001,inetAddress);//creo la socket
		 
		 System.out.println("Name Server avviato..."); 
	     for(;;){//ciclo del server
		 byte buffer[]=new byte[65536];//creo un buffer
		 DatagramPacket dPacket= new DatagramPacket(buffer,buffer.length);//nuovo pacchetto
		 
		 dSocket.receive(dPacket);//mi metto in ascolto
		 
		 Estrai estrai=new Estrai(dPacket);     //estraggo i dati e li passo ad un thread
		 EntryCommand entry=estrai.estraiDati();//(lo faccio qui per velocizzare i thread)
		 
		 new Thread(new Gestore(dPacket,entry)).start();
		 }
		 
	    }catch(UnknownHostException e)
	    {e.printStackTrace();
	    }
		 catch(SocketException e)
		{e.printStackTrace();
		}
		catch(Exception e)
		{System.out.println("problema in getAddress()");
	     e.printStackTrace();	
		}	  
       }

//------------	   
	   
	 public void replicator()
	   {
	    try{
		System.out.println("Caricamento tabella SLAVE....");
	        InetAddress inetAddress=InetAddress.getByName(slave);
	        Socket socket;
	        
	        try{
	        socket=new Socket(inetAddress,2003);

			
		InputStream in=socket.getInputStream();
		
		int x;
		ByteArrayOutputStream line=new ByteArrayOutputStream();
		ByteArrayOutputStream car=new ByteArrayOutputStream();
		
		while((x=in.read())>-1)
		{car.reset();
		 car.write(x);
		 //----------------
		 if(car.toString().equals("$"))  //fine entry
		 {char tochar[]=line.toString().toCharArray();
		  int i=0;
		 
		  StringBuffer command=new StringBuffer();
	          StringBuffer host=new StringBuffer();
	          StringBuffer nome=new StringBuffer();
	  
	          while (tochar[i]!='&')
	           { 
	  	       command=command.append(tochar[i]);
		       i++;
	           }
		  i++;
				
	          while (tochar[i]!='&')
	           { 
	  	       host=host.append(tochar[i]);
		       i++;
	           } 
	          i++;
				
	          while (tochar[i]!='&')
	           {  
	  	        nome=nome.append(tochar[i]);
				i++;
	           }

                Entry entry=new Entry(host.toString(),
nome.toString());
		tabella.insert(entry);
		line.reset();//svuota la linea
		}
		//--------------
		else
		{line.write(x);
		}
		//--------------
		
	    }//fine while
	    
	    }catch(ConnectException e)   //se slave non presente si prosegue
            { 
            }
            
            InviaTabella inviaTabella= new InviaTabella();
            new Thread(inviaTabella).start();
            		
	    }catch(SocketException e)
	    {e.printStackTrace();
	    }
		 catch(IOException e)
		 {e.printStackTrace();
		 }
	   
	   }

//--------------
	   
    public static void main(String args[]) throws IOException
	   { 
	   	 Tabella tabella=new Tabella();
	   	 InetReceiver inet = new InetReceiver(tabella,args[0]);
				 
	     inet.replicator();
	     inet.startServer();
	   }
}

//**********************************

class Entry
{protected String host;
 protected String nomefile;
 protected int time;
 public Entry(String host,String nomefile)
 {this.host=host;
  this.nomefile=nomefile;
  this.time=0;
  }
 public Entry(String host,String nomefile,int time)
 {this.host=host;
  this.nomefile=nomefile;
  this.time=time;
  }
 public Entry()
 {this.time=0;
 }
  
 public String getHost()
 {return(host);
 }
 public String getFilename()
 {return(nomefile);
 }
 public int getTime()
 {
  return(time);
 }
 public void setTime(int time)
 {this.time=time;
 }
}



//*******************************



class EntryCommand extends Entry
{protected String command;
 public EntryCommand(String command,String host,String nomefile)
 {super(host,nomefile);
  this.command=command;
 }
 public String getCommand()
 {return(command);
 }
}

//******************************

class Estrai
{ protected DatagramPacket packet; 
  public Estrai(DatagramPacket packet)
  {this.packet=packet;
  }
  public EntryCommand estraiDati() throws IOException
  {       
             ByteArrayInputStream biStream=new ByteArrayInputStream(packet.getData(),0,
		                                              packet.getLength());
		     DataInputStream diStream=new DataInputStream(biStream); 
             String message = diStream.readUTF();
			  //il messaggio viene interpretato
			 char tochar[]=message.toCharArray();
			 int i=0;
	  
                 StringBuffer command=new StringBuffer();
	         StringBuffer host=new StringBuffer();
	         StringBuffer nome=new StringBuffer();
	  
	         while (tochar[i]!='&')
	         { 
	  	       command=command.append(tochar[i]);
			   i++;
	         }
		     i++;
				
	         while (tochar[i]!='&')
	         { 
	  	       host=host.append(tochar[i]);
			   i++;
	         } 
	         i++;
				
	         while (tochar[i]!='&')
	         {  
	  	        nome=nome.append(tochar[i]);
				i++;
	         }

             EntryCommand entry=new EntryCommand(command.toString(),host.toString(),
			 		                  nome.toString());
				  
			 return(entry);
            
			
  }
}


//********************

class Tabella
{ public static int NUM=1000; 
  Entry tabella[]=new Entry[NUM];
  boolean full[]=new boolean[NUM];
  
  public Tabella()
  {for(int i=0;i<NUM;i++)full[i]=false;
   for(int i=0;i<NUM;i++)tabella[i]=new Entry("","");
  }
  
  synchronized public Entry getByIndex(int position)
  {return(tabella[position]);
  }
  
  synchronized public void insert(Entry entry)
  {int i;
   for(i=0;full[i]==true;i++);
   tabella[i]=entry;
   full[i]=true;
  }
  
  synchronized public Entry getByFilename(String nomefile) 
  {for(int i=0;i<NUM;i++)
  	 if(tabella[i].getFilename().equals(nomefile))return(tabella[i]);
   return(new Entry("","")); 
  }
  
  synchronized public Entry getByFilenameTozero(String nomefile)
  {Entry entry = new Entry();			 //si richiede una entry della tabella ad uso di un client
   entry = this.getByFilename(nomefile); //quindi bisogna azzerare il campo time
   this.removeByFilename(entry.getFilename());
   this.insert(new Entry(entry.getHost(),entry.getFilename()));
   return(entry);
  }
  
  synchronized public Entry getByIndexT(int position,int maxTime)
  {Entry entry=this.getByIndex(position);    //restituisce al thread la entry di indice position
   if(entry.getFilename().equals(""))        //e, solo se contiene il nome di un file,
       return(entry);				         //incrementa il tempo di vita della entry
   int time=entry.getTime();                 //se non  pi vecchia di maxTime, altrimenti                
   if (time<=maxTime)                        //la rimuove dalla tabella 
   {                                   
    this.removeByFilename(entry.getFilename());
    this.insert(new Entry(entry.getHost(),entry.getFilename(),time+1));	
	return(entry);
   }
   else 
   {this.removeByFilename(entry.getFilename());
    return(entry);
   }
  }
	 
  
  synchronized public void removeByFilename(String nomefile)
  {int i;
   for(i=0;i<NUM;i++)
  	 if (tabella[i].getFilename().equals(nomefile))
	 {tabella[i]=new Entry("","");
	  full[i]=false; 
	  return;
	 }
  }
  
  synchronized public void setMaxtimeByFilename(String nomefile, int maxTime)
  {
   Entry entry=this.getByFilename(nomefile);
   this.removeByFilename(nomefile);
   this.insert(new Entry(entry.getHost(),entry.getFilename(),maxTime));
  }
}
    

//********************


